<html>
	<head>
		<meta charset="utf-8"/>
		<script src="wasm_exec.js"></script>

	</head>
	<body>
		<h1>WASM Experiments</h1>
		<script>

			if (!WebAssembly.instantiateStreaming) { // polyfill
				WebAssembly.instantiateStreaming = async (resp, importObject) => {
					const source = await (await resp).arrayBuffer()
					return await WebAssembly.instantiate(source, importObject)
				}
			}

      function loadWasm(path) {
        const go = new Go()
				//remove the message: syscall/js.finalizeRef not implemented
        // https://github.com/tinygo-org/tinygo/issues/1140
        // go.importObject.env["syscall/js.finalizeRef"] = () => {}


        return new Promise((resolve, reject) => {
          WebAssembly.instantiateStreaming(fetch(path), go.importObject)
          .then(result => {
            go.run(result.instance)
            resolve(result.instance)
          })
          .catch(error => {
            reject(error)
          })
        })
      }


			loadWasm("main.wasm").then(wasm => {
        console.log("main.wasm is loaded 👋")

				console.log(Hello("Bob Morane"))
        document.querySelector("h1").innerHTML = Hello("Bob Morane")

			}).catch(error => {
        console.log("ouch", error)
      }) 

		</script>
	</body>
</html>
